%include "unit.inc"

BUF_ADR equ	0x0A00

test_suite:
	call ts_equal
	call ts_not_equal
	ret

nexpected:	db "expected ","$"
nobtained:	db " obtained ","$"

nsuite:		db "tstcore;","$"

npositivetest:	db "jmp_len is 3;","$"
nnegativetest:	db "jmp_len is not 18;","$"

EXPECTED equ 3

ts_equal:
	puts nsuite
	puts npositivetest
	mov AX, EXPECTED
	cmp AX, jmp_length
	je ts_equal_ok
	puts nko
	puts nfail
	jmp ts_equal_end
ts_equal_ok:
	puts nok
	puts npass
ts_equal_end:
	puts nexpected
	putw EXPECTED
	puts nobtained
	putw jmp_length
	puts ncrlf
	ret
	
UNEXPECTED equ 18
ts_not_equal:
	puts nsuite
	puts nnegativetest
	mov AX, UNEXPECTED
	cmp AX, jmp_length
	jne ts_not_equal_ok
	puts npass
	puts nko
	jmp ts_not_equal_end
ts_not_equal_ok:
	puts nok
	puts nfail
ts_not_equal_end:
	puts nexpected
	putw UNEXPECTED
	puts nobtained
	putw jmp_length
	puts ncrlf
	ret

%include "picoforth.mac"
%include "picotable.inc"
%include "picoforth.inc"
%include "picohw.inc"

dumb_called:
	ret
