[BITS 16]	; 16 bits plain binary output
[ORG 0x0600]	; code origin, where the bios loads it
	nop 
	nop
	jmp start
	db "README  ",0
start:
	mov ax, message
	mov si,ax
	
start_loop:
	lodsb
	cmp al, 0
	je stop_loop
	mov ah, 0x0E	; bios int 10h, function 0Eh - print char in tty mode
	mov bh, 0x00	; page no
	mov bl, 0x07	; text attribute

	int 0x10	; call bios
	jmp start_loop
stop_loop:
	ret

message 	db 13,10
		db "This is 512b, a 512 byte (not-an-)OS by Jean Buchet",13,10
		db 13,10
		db "Quick help:",13,10
		db 13,10
		db "v print version",13,10
		db "n select current sector + 1",13,10
		db "p select current sector - 1",13,10
		db "N select current sector + 10",13,10
		db "P select current sector - 10",13,10
		db "s show current sector",13,10
		db "l load current sector and display as asciiz",13,10
		db "r load current sector and run as binary",13,10
		db 13,10
x_filler:
	TIMES 512 - ($ - $$) - 1 db 0



			; end of file

