%include "unit.inc"

BUF_ADR equ	0x0A00

%include "picoforth.mac"
%include "picotable.inc"
%include "picoforth.inc"
%include "fakehw.inc"
%include "lba_chs.mac"

test_lba_chs  0, 0, 0,  1, "ts_lba_chs_000;"
test_lba_chs 10, 0, 0, 11, "ts_lba_chs_010;"
test_lba_chs  1, 0, 0,  2, "ts_lba_chs_001;"
test_lba_chs 17, 0, 0, 18, "ts_lba_chs_017;"
test_lba_chs 18, 0, 1,  1, "ts_lba_chs_018;"
test_lba_chs 19, 0, 1,  2, "ts_lba_chs_019;"
test_lba_chs 20, 0, 1,  3, "ts_lba_chs_020;"


test_suite:
	call ut_lba_chs_0
	call ut_lba_chs_10
	call ut_lba_chs_1
	call ut_lba_chs_17
	call ut_lba_chs_18
	call ut_lba_chs_19
	call ut_lba_chs_20
	ret

nexpected:	db "expected ","$"
nobtained:	db " obtained ","$"

nsuite:		db "ts_lba_chs;","$"
ntest:		db "nop","$"
l_slash:	db "/","$"


do_lba_to_chs:
	lba_to_chs 
	ret

;-----------------------------------------------------------------------------
;




