[BITS 16]	; 16 bits plain binary output

[ORG 0x0100]	; code origin, where the bios loads it


	jmp tst_start

nok:	db "Ok;","$"
nko:	db "Ko;","$"

nfail:	db "Fail;","$"
npass:	db "Pass;","$"

ncrlf:	db 13,10,"$"
nreturn:	db "return to dos","$"

%macro puts 1
	mov dx, %1
	call display_text
%endmacro

%macro putw 1
	mov dx, %1
	call display_word
%endmacro

%macro putb 1
	mov dl, %1
	mov dh, 0
	putw DX
%endmacro

%macro fetch_byte 1
	mov dl, byte [%1]
	mov dh, 0
%endmacro

display_word:
	push ax
	push bx

	mov ax, dx
	mov bx, 0xFFFF
	push BX
	MOV  BX, 10
CONV_decomp:
        xor dx, dx
        DIV  BX

        PUSH DX

	CMP  AX, 0
	JNE  CONV_decomp

conv_pop_c:
	pop AX
	cmp AX, 0xFFFF
	je fin_conv_c

	add AL, "0"
	mov dl, al
	call display_char
	jmp conv_pop_c
fin_conv_c:
	pop bx
	pop ax
	ret
	

display_char:
	push	ax
	push	dx
	mov	ah, 6
	int	21h
	pop	dx
	pop	ax
	ret

display_text:	;; dx must point to a $ terminated string
	mov ah, 9
	int 0x21
	ret

cannot_exit:	db "Cannot return to prompt","$"
exit_to_dos:
	mov ax, 0x4C00
	int 21h

	puts nsuite
	puts nreturn
	puts nko
	puts cannot_exit
	puts ncrlf
here:
	jmp here

tst_start:
	mov ax, cs
	mov ds, ax
	mov es, ax

	call test_suite

	call exit_to_dos




